import time
import sys
#
from System.Collections.Generic import List
from System import Byte
#
import common
common.Player = Player
common.Items = Items
common.Mobiles = Mobiles
common.Misc = Misc
common.Journal = Journal
common.Statics = Statics
common.Gumps = Gumps
common.Spells = Spells
common.BandageHeal = BandageHeal
# 

def find_any(containerSerial, typeArray):
    ret_list = []
    container = Items.FindBySerial(containerSerial)
    if container != None:
        for item in container.Contains:
            if item.ItemID in typeArray:
                ret_list.append(item)
            if item.IsContainer:
                for tmp in find_any(item.Serial, typeArray):
                    ret_list.append(tmp)
    return ret_list
    #
corpse_filter = Items.Filter()
corpse_filter.Enabled = 1
corpse_filter.IsCorpse = 1
corpse_filter.OnGround = 1
corpse_filter.RangeMin = -1
corpse_filter.RangeMax = 3
corpse_filter.Movable = False
corpses = Items.ApplyFilter(corpse_filter)
#
r_h = Player.GetItemOnLayer("RightHand")
l_h = Player.GetItemOnLayer("LeftHand")
def UseKnife():
    knives_in_pack = find_any(Player.Backpack.Serial, [0x0EC4]) #,  0x2D20, 0x0EC3, 0x0F52] )
    if len(knives_in_pack) > 0:
        knife_in_pack = knives_in_pack[0]
    else:
        knife_in_pack = None
    if Misc.ShardName( ) == "Lost_City":
        knife_in_hand = Player.GetItemOnLayer("RightHand")
        if (knife_in_hand == None or knife_in_hand.ItemID != 0xec3):
            if knife_in_pack == None:
                Misc.SendMessage("Unable to skin without a cleaver")
                stop()
            else:
                Items.UseItem(knife_in_pack) # puts it in r_h
                Misc.Pause(1000)
        Items.UseItem(Player.GetItemOnLayer("RightHand"))
    else:
        if knife_in_pack == None:
            Misc.SendMessage("Unable to skin without a cleaver")
        else:
            Items.UseItem(knife_in_pack)            
#
#
#
cut_able = [ 'llama', 'rabbit', 'hare', 'lizard', 'sheep', 'ratman', 'alligator', 'harpy', 'bear', 'chicken', 
'bull', 'cow', 'deer', 'goat', 'drake', 'dragon', 'wyvern', 'wyrm', 'daemon', 'serpent', 'roach',
'leopard'] 
if corpses != None:
    Misc.SendMessage("Starting")
    for corpse in corpses: 
        if Player.Weight >= Player.MaxWeight:
            sys.exit(99)
        #corpse_name = str(corpse.Properties[0])
        #Misc.SendMessage("Found {}".format(corpse_name))
        if True:    # any(name in corpse_name for name in cut_able):
            if Player.InRangeItem(corpse, 2):
                UseKnife()
                Target.WaitForTarget(2000, False)
                Target.TargetExecute(corpse.Serial)
                Misc.Pause(1000)                
                #
                scissors = Items.FindByID(0x0F9F, -1, Player.Backpack.Serial) 
                if scissors is not None:
                    items = find_any(Player.Backpack.Serial, [0x1079]) # hides
                    for item in items:
                        Items.UseItem(scissors.Serial)
                        Target.WaitForTarget(1000, True)
                        Target.TargetExecute(item.Serial)
                items = find_any(corpse.Serial, [0x1bd1, 0x1079, 0x0DF8, 0x26B4, 0x1081]) #  0x09F1
                if items != None:
                    for item in items:
                        if Misc.CheckSharedValue("BagOfHolding"):
                            Items.Move(item, Misc.ReadSharedValue("BagOfHolding"), 0)
                            Misc.Pause(1000)
                        elif Misc.CheckSharedValue("LootBag"):
                            Items.Move(item, Misc.ReadSharedValue("LootBag"), 0)                            
                            Misc.Pause(1000)        
                #
                if False and Misc.CheckSharedValue("ClaimCommand"):
                    Player.ChatSay(52, Misc.ReadSharedValue("ClaimCommand"))
                    Target.WaitForTarget(10000, True)
                    Target.TargetExecute(corpse.Serial)
        else:
            claim_command = Misc.ReadSharedValue("ClaimCommand")
            if "None" != claim_command:
                Player.ChatSay(52, claim_command)
                Target.WaitForTarget(10000, True)
                Target.TargetExecute(corpse.Serial)
                Misc.Pause(500)    
                Target.Cancel( )
    if Misc.CheckSharedValue("MasterCrystal"):
        crystal_storage = Misc.ReadSharedValue("MasterCrystal")
        Items.UseItem(crystal_storage)
        #Target.WaitForTarget(2000)
        Gumps.WaitForGump(3778238711, 10000)
        Gumps.SendAction(3778238711, 52)
        Gumps.WaitForGump(3778238711, 10000)
        Gumps.SendAction(3778238711, 0)
        if Misc.CheckSharedValue("GoldBasket"):
            gold = common.findRecursive(Player.Backpack.Serial, [0xeed])
            plat = common.findRecursive(Player.Backpack.Serial, [0x0EF0])
            for pile in gold + plat:
                Items.Move(pile.Serial, Misc.ReadSharedValue("GoldBasket"), 0)
                Misc.Pause(1000)
    Target.Cancel( )
else:
    Misc.SendMessage("No Corpses Found")
    #if shard == "Lost_City":
    #if r_h != None:
        #    Items.UseItem(r_h)
        #if l_h != None:
            #Items.UseItem(l_h)

